#include "channel.h"
#include "signal.h"

void channel_estimate(complex *z_ref,
                      complex *z_ref_in, complex *channel_out)
{
  int i;

  for (i = 0; i < T_U; i++) {
    /* in = h * z_ref
     * in * z_ref* = h * z_ref * z_ref*
     * in * z_ref* = h * (a^2 + b^2)
     * in * z_ref* / cabs(z_ref)^2 = h
     */
    double abs2 = creal(z_ref[i]) * creal(z_ref[i]) + cimag(z_ref[i]) * cimag(z_ref[i]);
    if (abs2 < 1e-10)
      channel_out[i] = 0;
    else {
      channel_out[i] = z_ref_in[i] * conj(z_ref[i]) / abs2;
      channel_out[i] = 1 / channel_out[i];
    }
  }
}

void channel_compensate(complex *in, complex *channel, complex *out)
{
  int i;
  for (i = 0; i < T_U; i++) {
    out[i] = channel[i] * in[i];
  }
}
