#include "frequency_offset.h"

#include <math.h>

#include "signal.h"

static complex table[2048000];

void init_frequency_offset(void)
{
  int i;

  for (i = 0; i < 2048000; i++)
    table[i] = cexp(I * 2 * M_PI * i / 2048000.);
}

double frequency_offset_fine(complex *symbol_time)
{
  complex freq_corr = 0;
  int i;
  for (i = T_U; i < T_S; i++)
    freq_corr += symbol_time[i] * conj(symbol_time[i - T_U]);
  return carg(freq_corr)/(2 * M_PI) * 1000;
}

int remove_frequency_offset(int cur_pos,
                            complex *symbol_time, int freq_offset_hz)
{
  int i;

  for (i = 0; i < T_S; i++) {
    symbol_time[i] *= table[cur_pos];
    cur_pos -= freq_offset_hz;
    if (cur_pos < 0) cur_pos += 2048000;
    if (cur_pos > 2048000) cur_pos -= 2048000;
  }

  return cur_pos;
}
